# This is the bottom part of the complete site-deployment-template.yaml

        # Readiness probes help Kubernetes know when to start sending traffic to the pod.
        #   This probe helps kubernetes to "add" or "remove" this pod from the service in front of it.
        #   So, when the probe passes it is added to the service,
        #       when it fails at any time in it's life, kubernetes removes it from the service.
        # Restarting the "stuck" container is the job of livenessProbe, explained further down.
        # Note: Readiness probe runs throughout the life of the container - every "periodSeconds",
        #       not just at the container start time!
        #
        # The WITPASS/wordpress images takes long to start, 
        #   because themes and plugins are pulled at container start time.
        # 

        # Note:
        # gasheatinginstallers.co.uk uses a very weird theme, "listingpro"
        # This theme needs some plugins to be installed everytime the container starts.
        # The regular readiness probe does not work, because the main page has error.
        # So we get licence.txt, which is always there in wordpress installations. 

        readinessProbe:
          httpGet:
            path: /license.txt
            port: 80
          initialDelaySeconds: 5
          # Retry the probe every X seconds (frequency):
          periodSeconds: 5
          # Number of times this probe can fail ,
          #   before kubernetes gives up and marks the "pod" as "Unready":
          failureThreshold: 60
          # This sites takes a lot of time to boot up.
          # In the case above, the Pod will be marked "Unready",
          #   if the probe does not pass 5 x 60 = 300 seconds. = 5 minutes
          successThreshold: 1
          
        ports:
        - containerPort: 80
          name: http

        resources:
          requests:
            cpu: 100m
            memory: 192Mi
          limits:
            cpu: 200m
            memory: 256Mi

        volumeMounts:
        - name: volume-SITE_ID
          mountPath: /var/www/html/wp-content

      volumes:
      - name: volume-SITE_ID
        persistentVolumeClaim:
          claimName: pvc-SITE_ID

---

# We need service
apiVersion: v1
kind: Service
metadata:
  name: SITE_ID
  labels:
    app: SITE_ID
    tier: frontend
    apptype: wordpress
spec:
  ports:
    - port: 80
  selector:
    app: SITE_ID
    tier: frontend
    apptype: wordpress
  type: ClusterIP

---

# We need an ingress
# apiVersion: extensions/v1beta1 - obsolete and incompatible with new API.
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: SITE_ID
  labels:
    app: SITE_ID
    tier: frontend
    apptype: wordpress
spec:
  rules:
  - host: SITE_NAME
    http:
      paths:
      - path: /
        pathType: Prefix
        backend:
          service:
            name: SITE_ID
            port:
              number: 80
  - host: www.SITE_NAME
    http:
      paths:
      - path: /
        pathType: Prefix
        backend:
          service:
            name: SITE_ID
            port:
              number: 80

